from collections import namedtuple

conv2ntuple = lambda fields: namedtuple('namedtuple', fields)(*fields)

MessageFieldsConstants = conv2ntuple(['data', #main field with data
                                      'error', 
                                      'metrics',
                                      'alerts',
                                      'named_features',  #dict for exclusive ch table
                                      'to_detector', #for Detector only
                                      'raw_alerts', #for Detector only, will not write to clickhouse
                                      'kafka_key', # will be written to key field
                                      'is_live',
                                      'timestamp', # event timestamp in ms (153718528187)
                                      'destination'])

outgoing_fields = ['data', 'timestamp'] #fields in messages which must be sent to output

VALID_ACTOR_TYPES  = conv2ntuple(['reducer', 'mapper', 'dispatcher', 'detector'])

API_IN_TOPIC = 'fabrique.api.in'
MONITOR_IN_TOPIC = 'fabrique.monitor.in'